import csv
from time import sleep

from data.sig_ref import SIGRef
from providers.sigrefdata.file_download_sig_ref_data_provider import FileDownloadSIGRefDataProvider


class POTA(FileDownloadSIGRefDataProvider):
    """SIG ref data provider for Parks on the Air"""

    POLL_INTERVAL_DAYS = 7
    SIG = "POTA"
    DATA_URL = "https://pota.app/all_parks_ext.csv"

    def __init__(self, provider_config):
        super().__init__(self.SIG, provider_config, self.DATA_URL, self.POLL_INTERVAL_DAYS)

    def _http_response_to_data(self, http_response):
        new_data = []
        for row in csv.DictReader(http_response.content.decode("utf-8-sig").splitlines()):
            ref_id = row["reference"]
            new_data.append(SIGRef(sig=self.SIG, id=ref_id, name=row["name"] if "name" in row else None,
                                      ref_type="Park",
                                      url="https://pota.app/#/park/" + ref_id,
                                      grid=row["grid"] if "grid" in row else None,
                                      latitude=float(row["latitude"]) if "latitude" in row and row[
                                          "latitude"] != "" else None,
                                      longitude=float(row["longitude"]) if "longitude" in row and row[
                                          "longitude"] != "" else None))

            # Bail out if a stop has been requested, i.e. the program is shutting down - no need to parse the rest of
            # the data in this case
            if self._stop_event.is_set():
                break

            # Very short pause. This will extend the time to handle sig refs by a few seconds but will ensure some time
            # is available for other threads e.g. the web server.
            sleep(0.001)

        return new_data
